---
title: Update API Service Operation
description: The PUT {{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}} request updates an API service operation associated with the environment and API service specified in the request URL.
component: pingone-api
page_id: pingone-api:authorize:api-access-management/api-operations/update-api-server-operation
canonical_url: https://developer.pingidentity.com/pingone-api/authorize/api-access-management/api-operations/update-api-server-operation.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Update API Service Operation

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}
```

The `PUT {{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}` request updates an API service operation associated with the environment and API service specified in the request URL.

### Prerequisites

* Refer to [PingOne Authorize API Access Management](../../api-access-management.html) for important overview information.

> **Collapse: Request Model**
>
> For property descriptions, refer to [API service operations data model](../api-operations.html#api-server-operations-data-model).
>
> | Property                                | Type?        | Required? |
> | --------------------------------------- | ------------ | --------- |
> | `accessControl`                         | Object       | Optional  |
> | `accessControl.custom`                  | Object       | Optional  |
> | `accessControl.custom.enabled`          | Boolean      | Optional  |
> | `accessControl.group`                   | Object       | Optional  |
> | `accessControl.group.groups`            | Array        | Required  |
> | `accessControl.group.groups.element`    | Relationship | Required  |
> | `accessControl.group.groups.element.id` | String       | Required  |
> | `accessControl.permission`              | Object       | Optional  |
> | `accessControl.permission.id`           | Object       | Optional  |
> | `accessControl.scope`                   | Object       | Optional  |
> | `accessControl.scope.matchType`         | String       | Optional  |
> | `accessControl.scope.scopes`            | Array        | Required  |
> | `accessControl.scope.scopes.element`    | Object       | Required  |
> | `accessControl.scope.scopes.element.id` | String       | Required  |
> | `methods`                               | Array        | Optional  |
> | `name`                                  | String       | Required  |
> | `paths`                                 | Array        | Required  |
> | `paths.type`                            | String       | Required  |
> | `paths.pattern`                         | String       | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "name": "Accounts",
    "paths": [
        {
            "type": "EXACT",
            "pattern": "/accounts"
        }
    ],
    "methods": [
        "POST",
        "PUT"
    ],
    "accessControl": {
        "group": {
            "groups": [
                {
                    "id": "{endUserGroupId}"
                }
            ]
        },
        "scope": {
            "matchType": "ANY",
            "scopes": [
                {
                    "id": "{scopeID}"
                },
                {
                    "id": "{secondScopeId}"
                }
            ]
        }
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "name": "Accounts",
    "paths": [
        {
            "type": "EXACT",
            "pattern": "/accounts"
        }
    ],
    "methods": [
        "POST",
        "PUT"
    ],
    "accessControl": {
        "group": {
            "groups": [
                {
                    "id": "{endUserGroupId}"
                }
            ]
        },
        "scope": {
            "matchType": "ANY",
            "scopes": [
                {
                    "id": "{scopeID}"
                },
                {
                    "id": "{secondScopeId}"
                }
            ]
        }
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""name"": ""Accounts""," + "\n" +
@"    ""paths"": [" + "\n" +
@"        {" + "\n" +
@"            ""type"": ""EXACT""," + "\n" +
@"            ""pattern"": ""/accounts""" + "\n" +
@"        }" + "\n" +
@"    ]," + "\n" +
@"    ""methods"": [" + "\n" +
@"        ""POST""," + "\n" +
@"        ""PUT""" + "\n" +
@"    ]," + "\n" +
@"    ""accessControl"": {" + "\n" +
@"        ""group"": {" + "\n" +
@"            ""groups"": [" + "\n" +
@"                {" + "\n" +
@"                    ""id"": ""{endUserGroupId}""" + "\n" +
@"                }" + "\n" +
@"            ]" + "\n" +
@"        }," + "\n" +
@"        ""scope"": {" + "\n" +
@"            ""matchType"": ""ANY""," + "\n" +
@"            ""scopes"": [" + "\n" +
@"                {" + "\n" +
@"                    ""id"": ""{scopeID}""" + "\n" +
@"                }," + "\n" +
@"                {" + "\n" +
@"                    ""id"": ""{secondScopeId}""" + "\n" +
@"                }" + "\n" +
@"            ]" + "\n" +
@"        }" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}"
  method := "PUT"

  payload := strings.NewReader(`{
    "name": "Accounts",
    "paths": [
        {
            "type": "EXACT",
            "pattern": "/accounts"
        }
    ],
    "methods": [
        "POST",
        "PUT"
    ],
    "accessControl": {
        "group": {
            "groups": [
                {
                    "id": "{endUserGroupId}"
                }
            ]
        },
        "scope": {
            "matchType": "ANY",
            "scopes": [
                {
                    "id": "{scopeID}"
                },
                {
                    "id": "{secondScopeId}"
                }
            ]
        }
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "name": "Accounts",
    "paths": [
        {
            "type": "EXACT",
            "pattern": "/accounts"
        }
    ],
    "methods": [
        "POST",
        "PUT"
    ],
    "accessControl": {
        "group": {
            "groups": [
                {
                    "id": "{endUserGroupId}"
                }
            ]
        },
        "scope": {
            "matchType": "ANY",
            "scopes": [
                {
                    "id": "{scopeID}"
                },
                {
                    "id": "{secondScopeId}"
                }
            ]
        }
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"name\": \"Accounts\",\n    \"paths\": [\n        {\n            \"type\": \"EXACT\",\n            \"pattern\": \"/accounts\"\n        }\n    ],\n    \"methods\": [\n        \"POST\",\n        \"PUT\"\n    ],\n    \"accessControl\": {\n        \"group\": {\n            \"groups\": [\n                {\n                    \"id\": \"{endUserGroupId}\"\n                }\n            ]\n        },\n        \"scope\": {\n            \"matchType\": \"ANY\",\n            \"scopes\": [\n                {\n                    \"id\": \"{scopeID}\"\n                },\n                {\n                    \"id\": \"{secondScopeId}\"\n                }\n            ]\n        }\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "name": "Accounts",
    "paths": [
      {
        "type": "EXACT",
        "pattern": "/accounts"
      }
    ],
    "methods": [
      "POST",
      "PUT"
    ],
    "accessControl": {
      "group": {
        "groups": [
          {
            "id": "{endUserGroupId}"
          }
        ]
      },
      "scope": {
        "matchType": "ANY",
        "scopes": [
          {
            "id": "{scopeID}"
          },
          {
            "id": "{secondScopeId}"
          }
        ]
      }
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "name": "Accounts",
    "paths": [
      {
        "type": "EXACT",
        "pattern": "/accounts"
      }
    ],
    "methods": [
      "POST",
      "PUT"
    ],
    "accessControl": {
      "group": {
        "groups": [
          {
            "id": "{endUserGroupId}"
          }
        ]
      },
      "scope": {
        "matchType": "ANY",
        "scopes": [
          {
            "id": "{scopeID}"
          },
          {
            "id": "{secondScopeId}"
          }
        ]
      }
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}"

payload = json.dumps({
  "name": "Accounts",
  "paths": [
    {
      "type": "EXACT",
      "pattern": "/accounts"
    }
  ],
  "methods": [
    "POST",
    "PUT"
  ],
  "accessControl": {
    "group": {
      "groups": [
        {
          "id": "{endUserGroupId}"
        }
      ]
    },
    "scope": {
      "matchType": "ANY",
      "scopes": [
        {
          "id": "{scopeID}"
        },
        {
          "id": "{secondScopeId}"
        }
      ]
    }
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "name": "Accounts",\n    "paths": [\n        {\n            "type": "EXACT",\n            "pattern": "/accounts"\n        }\n    ],\n    "methods": [\n        "POST",\n        "PUT"\n    ],\n    "accessControl": {\n        "group": {\n            "groups": [\n                {\n                    "id": "{endUserGroupId}"\n                }\n            ]\n        },\n        "scope": {\n            "matchType": "ANY",\n            "scopes": [\n                {\n                    "id": "{scopeID}"\n                },\n                {\n                    "id": "{secondScopeId}"\n                }\n            ]\n        }\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "name": "Accounts",
  "paths": [
    {
      "type": "EXACT",
      "pattern": "/accounts"
    }
  ],
  "methods": [
    "POST",
    "PUT"
  ],
  "accessControl": {
    "group": {
      "groups": [
        {
          "id": "{endUserGroupId}"
        }
      ]
    },
    "scope": {
      "matchType": "ANY",
      "scopes": [
        {
          "id": "{scopeID}"
        },
        {
          "id": "{secondScopeId}"
        }
      ]
    }
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"name\": \"Accounts\",\n    \"paths\": [\n        {\n            \"type\": \"EXACT\",\n            \"pattern\": \"/accounts\"\n        }\n    ],\n    \"methods\": [\n        \"POST\",\n        \"PUT\"\n    ],\n    \"accessControl\": {\n        \"group\": {\n            \"groups\": [\n                {\n                    \"id\": \"{endUserGroupId}\"\n                }\n            ]\n        },\n        \"scope\": {\n            \"matchType\": \"ANY\",\n            \"scopes\": [\n                {\n                    \"id\": \"{scopeID}\"\n                },\n                {\n                    \"id\": \"{secondScopeId}\"\n                }\n            ]\n        }\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/operations/{{apiServerOperationID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": ".../environments/{envID}/apiServers/{serverId}/operations/{ID}"
        },
        "apiServer": {
            "href": ".../environments/{envID}/apiServers/{serverId}"
        }
    },
    "name": "Accounts",
    "id": "{operationId}",
    "paths": [
        {
            "type": "EXACT",
            "pattern": "/accounts"
        }
    ],
    "methods": [
        "POST",
        "PUT"
    ],
    "accessControl": {
        "group": {
            "groups": [
                {
                    "id": "{endUserGroupId}"
                }
            ]
        },
        "scope": {
            "matchType": "ANY",
            "scopes": [
                {
                    "id": "{scopeID}"
                },
                {
                    "id": "{secondScopeId}"
                }
            ]
        }
    }
}
```
